/*	Prova 18 Luglio 2006

	Realizzare tre classi thread: "RobotR", "RobotG" e "RobotB", ciascuno dei quali  in
	grado di prelevare elementi rispettivamente da tre code: "CodaR", "CodaG" e "CodaB".
	Gli elementi devono essere estratti sempre uno alla volta in mutua esclusione.
	Ciascun robot una volta estratto l'elemento dalla sua coda lo deve inserire in una
	coda comune "CodaRGB" rispettando quest'ordine: "RGGBRGGB...".
	Scrivere un programma che crei quattro oggetti: "codaR", "codaG", "codaB" e "codaRGB"
	ed avvii l'esecuzione di 2 thread "RobotR", 4 thread "RobotG" e 2 thread "RobotB",
	ciascuno dei quali dovr effettuare un certo numero di estrazioni ed inserimenti in sequenza.

	Codice: Enrico Saviano http://enrico.saviano.org
*/

class A_060718 {
	public static void main(String args[]) {
		Coda CodaR = new Coda(), CodaG = new Coda(), CodaB = new Coda(), CodaRGB = new Coda();
		Semaforo R = new Semaforo (1);
		Semaforo G = new Semaforo (0);
		Semaforo B = new Semaforo (0);
		Semaforo mutex = new Semaforo(1);
		RobotR R1 = new RobotR("R1", 3, CodaR, CodaRGB, R, G, mutex);
		RobotR R2 = new RobotR("R2", 3, CodaR, CodaRGB, R, G, mutex);
		RobotG G1 = new RobotG("G1", 3, CodaG, CodaRGB, G, B, mutex);
		RobotG G2 = new RobotG("G2", 3, CodaG, CodaRGB, G, B, mutex);
		RobotG G3 = new RobotG("G3", 3, CodaG, CodaRGB, G, B, mutex);
		RobotG G4 = new RobotG("G4", 3, CodaG, CodaRGB, G, B, mutex);
		RobotB B1 = new RobotB("B1", 3, CodaB, CodaRGB, B, R, mutex);
		RobotB B2 = new RobotB("B2", 3, CodaB, CodaRGB, B, R, mutex);
		R1.start(); R2.start(); G1.start(); G2.start(); G3.start();
		G4.start(); B1.start(); B2.start();
	}
}
class Coda {
	public void preleva() { }
	public void inserisci() { }
}

class RobotR extends Thread {
	String nome;
	Coda CodaR, CodaRGB;
	int giri;
	static Semaforo interno = new Semaforo(1);
	Semaforo R, G, mutex;

	RobotR (String nome, int giri, Coda CodaR, Coda CodaRGB, Semaforo R, Semaforo G, Semaforo mutex) {
		this.nome = nome;
		this.giri = giri;
		this.CodaR = CodaR;
		this.CodaRGB = CodaRGB;
		this.R = R;
		this.G = G;
		this.mutex = mutex;
	}
	public void run() {
		while(giri!=0) {
		R.down();
		interno.down();
		mutex.down();
		System.out.println(nome+" preleva elemento dalla coda e lo inserisce in RGB");
		CodaR.preleva();
		CodaRGB.inserisci();
		giri--;
		mutex.up();
		interno.up();
		G.up();
		G.up();
		}
	}
}

class RobotG extends Thread {
	String nome;
	Coda CodaG, CodaRGB;
	int giri;
	static Semaforo interno = new Semaforo(1);
	Semaforo G, B, mutex;

	RobotG (String nome, int giri, Coda CodaG, Coda CodaRGB, Semaforo G, Semaforo B, Semaforo mutex) {
		this.nome = nome;
		this.giri = giri;
		this.CodaG = CodaG;
		this.CodaRGB = CodaRGB;
		this.B = B;
		this.G = G;
		this.mutex = mutex;
	}
	public void run() {
		while(giri!=0) {
		G.down();
		interno.down();
		mutex.down();
		System.out.println(nome+" preleva elemento dalla coda e lo inserisce in RGB");
		CodaG.preleva();
		CodaRGB.inserisci();
		giri--;
		mutex.up();
		interno.up();
		B.up();
		}
	}
}
class RobotB extends Thread {
	String nome;
	Coda CodaB, CodaRGB;
	int giri;
	static Semaforo interno = new Semaforo(1);
	Semaforo B, R, mutex;

	RobotB (String nome, int giri, Coda CodaB, Coda CodaRGB, Semaforo B, Semaforo R, Semaforo mutex) {
		this.nome = nome;
		this.giri = giri;
		this.CodaB = CodaB;
		this.CodaRGB = CodaRGB;
		this.R = R;
		this.B = B;
		this.mutex = mutex;
	}
	public void run() {
		while(giri!=0) {
		B.down();
		interno.down();
		mutex.down();
		System.out.println(nome+" preleva elemento dalla coda e lo inserisce in RGB");
		CodaB.preleva();
		CodaRGB.inserisci();
		giri--;
		mutex.up();
		interno.up();
		R.up();
		}
	}
}
