/*	Prova 3 Ottobre 2006

	In una partita di doppio a tennis i thread A e B giocano insieme a destra mentre
	i thread C e D giocano insieme a sinistra. Il primo giocatore ad iniziare la partita
	 il giocatore C della squadra di sinistra. A rispondere al servizio di C pu essere
	indifferentemente o A o B. Da questo punto in poi i giocatori della stessa squadra
	si alternano nel colpire la pallina quando, ovviamente, la pallina si trova nel loro
	campo. Realizzare la simulazione di una partita infinita con questo tipo
	di sincronizzazione utilizzando i semafori.

	Codice: Enrico Saviano http://enrico.saviano.org
*/

class A_061003 {
	public static void main(String args[]) {
		Semaforo a = new Semaforo(1); Semaforo b = new Semaforo(0);
		Semaforo c = new Semaforo(0); Semaforo d = new Semaforo(0);

		Giocatore A = new Giocatore("A", a, b, c, d);
		Giocatore B = new Giocatore("B", a, b, c, d);
		Giocatore C = new Giocatore("C", a, b, c, d);
		Giocatore D = new Giocatore("D", a, b, c, d);

		A.start(); B.start(); C.start(); D.start();
	}
}

class Giocatore extends Thread {
	String nome;
	Semaforo a,b,c,d;
	static boolean servizio = true;
	static int next = 0;
	private int nome2;

	public Giocatore(String nome, Semaforo a, Semaforo b, Semaforo c, Semaforo d) {
		this.nome = nome;
		this.a = a;
		this.b = b;
		this.c = c;
		this.d = d;
		if (nome == "A") 		{ nome2 = 1; }
		else if (nome == "B")	{ nome2 = 2; }
		else if (nome == "C")	{ nome2 = 3; }
		else 					{ nome2 = 4; }
	}

	public void run() {
		while (true) {
			switch(nome2) {
				case 1:
				{
					a.down();
					if (servizio) { next = (int) ( Math.round(Math.random()) ); servizio = false; }
					System.out.println("Giocatore "+nome+" gioca...");
					try { sleep(1000); } catch (InterruptedException e) {}
					if (next == 0) { c.up(); } else { d.up(); }
				}
				break;
				case 2:
				{
					b.down();
					System.out.println("Giocatore "+nome+" gioca...");
					try { sleep(1000); } catch (InterruptedException e) {}
					if (next == 0) { d.up(); } else { c.up(); }
				}
				break;
				case 3:
				{
					c.down();
					System.out.println("Giocatore "+nome+" gioca...");
					try { sleep(1000); } catch (InterruptedException e) {}
					if (next == 0) { b.up(); } else { a.up(); }
				}
				break;
				case 4:
				{
					d.down();
					System.out.println("Giocatore "+nome+" gioca...");
					try { sleep(1000); } catch (InterruptedException e) {}
					if (next == 0) { a.up(); } else { b.up(); }
				}
				break;
			}
		}
	}
}
